<?php
session_start();

//データベース接続情報を格納
include("config.php");

$txt_user = "";
$txt_email = "";
$txt_pass = "";
$hid_mode = "";

if($_SERVER['REQUEST_METHOD'] === 'POST'){

    //POSTデータの取得
    $txt_user = $_POST['txt_user'];
    $txt_email = $_POST['txt_email'];
    $txt_pass = $_POST['txt_pass'];
    $hid_mode = $_POST['hid_mode'];

    if($hid_mode == "1"){

      $err = "";

      if($txt_user == ""){
          $err .= "【ユーザー名】";
      }
      if($txt_email == ""){
          $err .= "【メールアドレス】";
      }
      if($txt_pass == ""){
          $err .= "【パスワード】";
      }

      if($err == ""){
          $sql = "insert into user_mst("
                  ."user_kj"
                  .",email"
                  .",password"
                  .",delete_ku"
                  .",insert_at"
                  .",update_at"
                  .") values ("
                  .":user_kj"
                  .",:email"
                  .",:password"
                  .",'0'"
                  .",now()"
                  .",now()"
                  .");";
          $dbh = new PDO($dsn, $user, $password);
          $dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
          $stmt = $dbh->prepare($sql);
          $stmt->bindValue(':user_kj', $txt_user, PDO::PARAM_STR);
          $stmt->bindValue(':email', $txt_email, PDO::PARAM_STR);
          $stmt->bindValue(':password', password_hash($txt_pass, PASSWORD_DEFAULT), PDO::PARAM_STR);
          if(!$stmt->execute()){
              return "データの書き込みに失敗しました。";
          }else{
              echo "登録完了しました";

              mb_language("Japanese");
              mb_internal_encoding("UTF-8");
              $to = $txt_email;
              $title = "会員登録完了";
              $content = $txt_user."さん、会員登録ができました。";

              $header = "MIME-Version: 1.0\n";
              $header .= "Content-Transfer-Encoding: 7bit\n";
              $header .= "Content-Type: text/plain; charset=ISO-2022-JP\n";
              $header .= "Message-Id: <" . md5(uniqid(microtime())) . "@test.com>\n";
              $header .= "from: test@test.com\n";
              $header .= "Reply-To: test@test.com\n";
              $header .= "Return-Path: test@test.com\n";
              $header .= "X-Mailer: PHP/". phpversion();

              if(mb_send_mail($to, $title, $content, $header)){
                  echo "メールを送信しました";
              } else {
                  echo "メールの送信に失敗しました";
              }
          }
      }else{
          echo $err."を修正してください。";
      }
    }else if($hid_mode == "9"){
      $err = "";

      if($txt_email == ""){
          $err .= "【メールアドレス】";
      }
      if($txt_pass == ""){
          $err .= "【パスワード】";
      }

      if($err == ""){
          try{
              $dbh = new PDO($dsn, $user, $password);
              $dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
              $sql = "select"
                      ." um.user_no"
                      .",um.user_kj"
                      .",um.password"
                      ." from user_mst um"
                      ." where um.email = :email"
                      ." and um.delete_ku = '0'";
              $stmt = $dbh->prepare($sql);
              $stmt->bindValue(':email', $txt_email , PDO::PARAM_STR);
              $stmt->execute();
              $result = $stmt->fetch();
              if(password_verify($txt_pass, $result['password'])){
                  //変数をセッションに登録
                  $_SESSION['user_no'] = $result['user_no'];
                  $_SESSION['user_kj'] = $result['user_kj'];
                  header("Location:user_list.php");
              }else{
                  echo "ログイン認証に失敗しました";
              } 
          }catch (PDOException $e){
              echo($e->getMessage());
              die();
          }
      }else{
          echo $err."を修正してください。";
      }
    }
}
?>

<!DOCTYPE html>
<html lang="ja">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <title>Responsive Web Design</title>
  <meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js"></script>
  <meta name="keywords" content="">
  <meta name="description" content="">
  <link rel="stylesheet" href="css/style.css">
  <link rel="stylesheet" href="css/login.css">
  <script language="javascript" type="text/javascript">

  function MJ_SIGNUP_SUBMIT(){

    let HidUser = document.getElementById('hid_user');
    let HidEmail = document.getElementById('hid_email_signup');
    let HidPass = document.getElementById('hid_pass_signup');

    if(HidUser.value == "9"){
    } else {
      bolErr = MJ_SIGNUP_USER();
    }
    if(HidEmail.value == "9"){
    } else {
      bolErr = MJ_SIGNUP_EMAIL();
    }
    if(HidPass.value == "9"){
    } else {
      bolErr = MJ_SIGNUP_PASS();
    }

    if(HidUser.value == "0" && HidEmail.value == "0" && HidPass.value == "0"){
      document.fr_signup.submit();
    }
  }

  function MJ_SIGNUP_USER(){
    let TxtUser = document.getElementById('txt_user');
    let DivUser = document.getElementById('div_user');
    let HidUser = document.getElementById('hid_user');

    if(TxtUser.value == ""){
      DivUser.innerHTML = "<div style='margin-top:10px;margin-bottom:0px;font-size:9px;'>ユーザー名が入力されていません</div>";
      HidUser.value = "9"; //9は、エラーとして処理
    } else {
      DivUser.innerHTML = "";
      HidUser.value = "0"; //0は、正常として処理
    }
  }

  function MJ_SIGNUP_EMAIL(){
    let TxtEmail = document.getElementById('txt_email_signup');
    let DivEmail = document.getElementById('div_email_signup');
    let HidEmail = document.getElementById('hid_email_signup');

    DivEmail.innerHTML = "";

    if(TxtEmail.value == ""){
      DivEmail.innerHTML = "<div style='margin-top:10px;margin-bottom:0px;font-size:9px;'>メールアドレスが入力されていません</div>";
      HidEmail.value = "9"; //9は、エラーとして処理
    } else {
      url = "webapi-chk_email.php?email="+TxtEmail.value;

      $.getJSON(url, (data) => {
        if(data["status"]=="9"){
          DivEmail.innerHTML = "<div style='margin-top:10px;margin-bottom:0px;font-size:9px;'>既に登録されているメールアドレスです</div>";
          HidEmail.value = "9"; //9は、エラーとして処理
        } else {
          HidEmail.value = "0"; //0は、正常として処理
        }
      });
    }
  }

  function MJ_SIGNUP_PASS(){
    let TxtPass = document.getElementById('txt_pass_signup');
    let DivPass = document.getElementById('div_pass_signup');
    let HidPass = document.getElementById('hid_pass_signup');

    if(TxtPass.value == ""){
      DivPass.innerHTML = "<div style='margin-top:10px;margin-bottom:0px;font-size:9px;'>パスワードが入力されていません</div>";
      HidPass.value = "9"; //9は、エラーとして処理
    } else {
      DivPass.innerHTML = "";
      HidPass.value = "0"; //0は、正常として処理
    }
  }


  function MJ_SIGNIN_SUBMIT(){

    let HidEmail = document.getElementById('hid_email_signin');
    let HidPass = document.getElementById('hid_pass_signin');

    if(HidEmail.value == "9"){
    } else {
      bolErr = MJ_SIGNIN_EMAIL();
    }
    if(HidPass.value == "9"){
    } else {
      bolErr = MJ_SIGNIN_PASS();
    }

    if(HidEmail.value == "0" && HidPass.value == "0"){
      document.fr_signin.submit();
    }
  }

  function MJ_SIGNIN_EMAIL(){
    let TxtEmail = document.getElementById('txt_email_signin');
    let DivEmail = document.getElementById('div_email_signin');
    let HidEmail = document.getElementById('hid_email_signin');

    if(TxtEmail.value == ""){
      DivEmail.innerHTML = "<div style='margin-top:10px;margin-bottom:0px;font-size:9px;'>メールアドレスが入力されていません</div>";
      HidEmail.value = "9"; //9は、エラーとして処理
    } else {
      DivEmail.innerHTML = "";
      HidEmail.value = "0"; //0は、正常として処理
    }
  }

  function MJ_SIGNIN_PASS(){
    let TxtPass = document.getElementById('txt_pass_signin');
    let DivPass = document.getElementById('div_pass_signin');
    let HidPass = document.getElementById('hid_pass_signin');

    if(TxtPass.value == ""){
      DivPass.innerHTML = "<div style='margin-top:10px;margin-bottom:0px;font-size:9px;'>パスワードが入力されていません</div>";
      HidPass.value = "9"; //9は、エラーとして処理
    } else {
      DivPass.innerHTML = "";
      HidPass.value = "0"; //0は、正常として処理
    }
  }

	function btn_signup(){
		const container = document.getElementById('container');
		container.classList.add("right-panel-active");
	};

	function btn_signin(){
		const container = document.getElementById('container');
		container.classList.remove("right-panel-active");
	};

  </script>
</head>
<body>

<div class="container" id="container">
  <div class="form-container sign-up-container">
    <form method="post" name="fr_signup">
      <h1>アカウント作成</h1>
	  <input type="hidden" name="hid_mode" value="1" />
      <div id="div_user" style="color:#ff0000;"></div>
      <input type="hidden" id="hid_user" value="0">
      <input type="text" placeholder="Name" name="txt_user" id="txt_user" onfocusout="MJ_SIGNUP_USER();"  />

      <div id="div_email_signup" style="color:#ff0000;"></div>
      <input type="hidden" id="hid_email_signup" value="0">
      <input type="email" placeholder="Email" name="txt_email" id="txt_email_signup" onfocusout="MJ_SIGNUP_EMAIL();" />

      <div id="div_pass_signup" style="color:#ff0000;"></div>
      <input type="hidden" id="hid_pass_signup" value="0">
      <input type="password" placeholder="Password" name="txt_pass" id="txt_pass_signup" onfocusout="MJ_SIGNUP_PASS();" />
      <button type="button" onclick="MJ_SIGNUP_SUBMIT();">サインアップ</button>
    </form>
  </div>
  <div class="form-container sign-in-container">
    <form method="post" name="fr_signin">
      <h1>サインイン</h1>
	  <input type="hidden" name="hid_mode" value="9" />
      <div id="div_email_signin" style="color:#ff0000;"></div>
      <input type="hidden" id="hid_email_signin" value="0">
      <input type="email" placeholder="Email" name="txt_email" id="txt_email_signin" onfocusout="MJ_SIGNIN_EMAIL();" />

      <div id="div_pass_signin" style="color:#ff0000;"></div>
      <input type="hidden" id="hid_pass_signin" value="0">
      <input type="password" placeholder="Password" name="txt_pass" id="txt_pass_signin" onfocusout="MJ_SIGNIN_PASS();" />
      <button type="button" onclick="MJ_SIGNIN_SUBMIT();">サインイン</button>
    </form>
  </div>
  <div class="overlay-container">
    <div class="overlay">
      <div class="overlay-panel overlay-left">
        <h1>おかえりなさい!</h1>
        <p>個人情報を使ってログインしてください。</p>
        <button class="ghost" id="signIn" onclick="btn_signin();">サインイン</button>
      </div>
      <div class="overlay-panel overlay-right">
        <h1>ユーザー登録</h1>
        <p>個人情報を入力して始めましょう。</p>
        <button class="ghost" id="signUp" onclick="btn_signup();">サインアップ</button>
      </div>
    </div>
  </div>
</div>
</body>
</html>