<!DOCTYPE html>
<html lang="ja">

<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge" />
	<title>Responsive Web Design</title>
	<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0">
	<meta name="keywords" content="">
	<meta name="description" content="">
	<link rel="stylesheet" href="css/style.css">
	<link rel="stylesheet" href="css/index.css">
</head>

<body>
	<!-- wrapper -->
	<div class="wrapper">
		<!-- header -->
		<header>
			<!-- Global Navigation -->
			<nav class="header-box">
				<div id="header-box-mb">
					<div class="header-box-mb-left">
						<input id="nav-input" type="checkbox" class="nav-unshown">
						<label id="nav-open" for="nav-input"><span></span></label>
						<label class="nav-unshown" id="nav-close" for="nav-input"></label>
						<div id="nav-content">
							<div class="hamburger-top"><label class="cancel" for="nav-input"><img
										src="img/menu-close48-48.png" alt="close"
										style="width:16px;height:auto;"></label></div>
							<div class="hamburger-border"></div>
							<div class="header-box-mb-menu">
								<div class="header-box-mb-menu-item"><a href="">ツナグーンとは</a></div>
								<div class="header-box-mb-menu-item"><a href="">プランと価格設定</a></div>
								<div class="header-box-mb-signin"><a href="user_list.php">サインイン</a></div>
								<div class="header-box-mb-signup"><a href="login.php"
										class="blue-botton">サインアップは無料です</a></div>
							</div>
						</div>
					</div>
					<div class="header-box-mb-center">
						<div class="header-box-mb-logo"><a href=""><img src="img/TSUNAGOON-Logo.png"
									alt="TSUNAGOON（ツナグーン）"></a></div>
					</div>
					<div class="header-box-mb-right">
					</div>
				</div>
				<div id="header-box-pc">
					<div class="header-box-pc-left">
						<div class="header-box-pc-left-logo"><a href=""><img src="img/TSUNAGOON-Logo.png"
									alt="TSUNAGOON（ツナグーン）"></a></div>
						<div class="header-box-pc-left-menu"><a href="">ツナグーンとは</a></div>
						<div class="header-box-pc-left-menu"><a href="">プランと価格設定</a></div>
					</div>
					<div class="header-box-pc-right">
						<div class="header-box-pc-right-menu"><a href="login.php">サインイン</a></div>
						<div class="header-box-pc-right-menu"><a href="login.php" class="blue-botton">サインアップは無料です</a>
						</div>
					</div>
				</div>
			</nav>
			<!-- /Global Navigation -->

		</header>
		<!-- /header -->

		<!-- main -->
		<main>
			<div class="main-width-setting">
				<div id="index-midashi">
					<div id="index-midashi-welcome">オンラインでイベント開催するツールが揃っています。</div>
					<div><a href="login.php" class="gray-button">サインアップは無料です</a></div><br>
				</div>
				<div><br><br></div>
			</div>
		</main>
		<!-- /main -->

		<!-- footer -->
		<footer>
			<div class="footer-box">
				<div class="footer-box-dat">
					<div class="footer-box-dat-logo"><a href="/"><img src="img/TSUNAGOON-Logo.png"
								alt="TSUNAGOON（ツナグーン）"></a></div>
					<div class="footer-box-dat-copyright">
						copyright ©2020 WELL FIELD corpolation. All rights reserved.
					</div>
				</div>

			</div>

		</footer>
		<!-- /footer -->

		<script src="js/script.js"></script>
		<!-- /wrapper -->
	</div>
</body>

</html>