<?php

//データベース接続情報を格納
include("config.php");

//GETで値を受け取る
if($_SERVER['REQUEST_METHOD'] === 'GET'){
    $email = $_GET['email'];
}

try{
    $dbh = new PDO($dsn, $user, $password);
    $dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    $sql = "select"
        ." um.user_no"
        ." from user_mst um"
        ." where um.email = :email"
        ." and um.delete_ku = '0';";
    $stmt = $dbh->prepare($sql);
    $stmt->bindValue(':email', $email , PDO::PARAM_STR);
    $stmt->execute();
    $result = $stmt->fetch();
}catch (PDOException $e){
    echo($e->getMessage());
    die();
}

/* データベースからの値を受け取る */
$rec_user_no = $result['user_no'];

$arr_data = array();
if($rec_user_no != "" || $email == "") {
    $arr_data = [
        "status" => "9"
    ];
} else {
    $arr_data = [
        "status" => "0"
    ];
}
header('content-type: application/json; charset=utf-8');
echo json_encode($arr_data);
?>